
#include <rpcrts.h>

typedef    rpc_char name[41];
typedef    rpc_char name_list[401];
typedef    rpc_long way_status;

program_index p_way;

extern rpc_long way_request();
/*  Parameters: 
    name service;
    rpc_integer version;
    rpc_integer compatibility;
    name_list pref_addresses;
    rpc_integer address_length;
    name address;
    */

extern rpc_long way_register();
/*  Parameters: 
    name service;
    rpc_integer version;
    rpc_integer compatibility;
    name address;
    */

extern rpc_long way_unregister();
/*  Parameters: 
    name service;
    rpc_integer version;
    name address;
    */

static rpc_message *rpc_p_buf;

r_way_request()
{
    name service;
    rpc_integer version;
    rpc_integer compatibility;
    name_list pref_addresses;
    rpc_integer address_length;
    name address;
    register rpc_integer rpc_a;
    register rpc_integer rpc_b;

   upk_integer(rpc_p_buf, rpc_b);
   for (rpc_a = 0; rpc_a < rpc_b; rpc_a++) {
   upk_char(rpc_p_buf, service[rpc_a]);
   }
   service[rpc_b] = '\0';
    if (rpc_p_buf->m_index%2) rpc_p_buf->m_index++;
   upk_integer(rpc_p_buf, version);
   upk_integer(rpc_p_buf, compatibility);
   upk_integer(rpc_p_buf, rpc_b);
   for (rpc_a = 0; rpc_a < rpc_b; rpc_a++) {
   upk_char(rpc_p_buf, pref_addresses[rpc_a]);
   }
   pref_addresses[rpc_b] = '\0';
    if (rpc_p_buf->m_index%2) rpc_p_buf->m_index++;
   upk_integer(rpc_p_buf, address_length);
    c_turn(rpc_p_buf);
    pck_long(rpc_p_buf, way_request(service, version, compatibility, 
        pref_addresses, address_length, address));
   for (rpc_b = 0; rpc_b <= 40; rpc_b++)
   if (address[rpc_b] == '\0') break;
   pck_integer(rpc_p_buf, rpc_b);
   for (rpc_a = 0; rpc_a < rpc_b; rpc_a++) {
   pck_char(rpc_p_buf, address[rpc_a]);
   }
    if (rpc_p_buf->m_index%2) rpc_p_buf->m_index++;
    }

r_way_register()
{
    name service;
    rpc_integer version;
    rpc_integer compatibility;
    name address;
    register rpc_integer rpc_a;
    register rpc_integer rpc_b;

   upk_integer(rpc_p_buf, rpc_b);
   for (rpc_a = 0; rpc_a < rpc_b; rpc_a++) {
   upk_char(rpc_p_buf, service[rpc_a]);
   }
   service[rpc_b] = '\0';
    if (rpc_p_buf->m_index%2) rpc_p_buf->m_index++;
   upk_integer(rpc_p_buf, version);
   upk_integer(rpc_p_buf, compatibility);
   upk_integer(rpc_p_buf, rpc_b);
   for (rpc_a = 0; rpc_a < rpc_b; rpc_a++) {
   upk_char(rpc_p_buf, address[rpc_a]);
   }
   address[rpc_b] = '\0';
    if (rpc_p_buf->m_index%2) rpc_p_buf->m_index++;
    c_turn(rpc_p_buf);
    pck_long(rpc_p_buf, way_register(service, version, compatibility, 
        address));
    }

r_way_unregister()
{
    name service;
    rpc_integer version;
    name address;
    register rpc_integer rpc_a;
    register rpc_integer rpc_b;

   upk_integer(rpc_p_buf, rpc_b);
   for (rpc_a = 0; rpc_a < rpc_b; rpc_a++) {
   upk_char(rpc_p_buf, service[rpc_a]);
   }
   service[rpc_b] = '\0';
    if (rpc_p_buf->m_index%2) rpc_p_buf->m_index++;
   upk_integer(rpc_p_buf, version);
   upk_integer(rpc_p_buf, rpc_b);
   for (rpc_a = 0; rpc_a < rpc_b; rpc_a++) {
   upk_char(rpc_p_buf, address[rpc_a]);
   }
   address[rpc_b] = '\0';
    if (rpc_p_buf->m_index%2) rpc_p_buf->m_index++;
    c_turn(rpc_p_buf);
    pck_long(rpc_p_buf, way_unregister(service, version, address));
    }

r_way(rpc_a) rpc_message **rpc_a;
{   rpc_short request;

    rpc_p_buf = *rpc_a;
    rpc_p_buf->m_index = CALL_HEADER_LENGTH - 4;
    upk_short(rpc_p_buf, request);
    if (request != 0 && request != 7130)
         rpc_p_buf->m_status = RPC_S_UNSUPPORTED_VERSION;
    else {
     upk_short(rpc_p_buf, request);
     switch (request)
     {   case  1 : r_way_request();
                  break;
        case  2 : r_way_register();
                  break;
        case  3 : r_way_unregister();
                  break;
        default : rpc_p_buf->m_status = RPC_S_BAD_PROCEDURE_NUMBER;
        }
     }
    }

attach_way()
{   rpc_status      status;

    c_attach_stub(status, r_way, 
        "way                                     ", p_way);
    c_report_error(status);
    }
